package com.syc.slm.slmbi.controller;

import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.google.common.collect.Maps;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.config.DataCenterConfig;
import com.syc.slm.slmbi.exception.SysException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * slm-bi
 * 获取token
 * @author : lin
 * @date : 2021-04-14 16:17
 **/
@RestController
@RequestMapping("/tokens")
@Api(value ="获取token",tags = "获取token")
public class TokenController extends BaseRestController{
    @Autowired
    private DataCenterConfig dataCenterConfig;

    @PostMapping
    @ApiOperation("获取token")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "account", value = "15865516442", required = true, dataTypeClass = String.class),
        @ApiImplicitParam(name = "password", value = "123456", required = true, dataTypeClass = String.class),
        @ApiImplicitParam(name = "origin", value = "0", required = true, dataTypeClass = String.class)
    })
    public R<Map<String,Object>> token(String account,String password,Integer origin){
        return  call(()->{
            Map<String ,Object> maps = Maps.newHashMap();
            String uri = dataCenterConfig.getDcClientHost() + "/user/token?account=" + account + "&password=" + password + "&origin=" + origin;
            ResponseEntity<Map> post = RestTemplateUtils.post(uri, Map.class);
            if(ObjectUtils.isNotEmpty(post)){
                Integer code = (int)post.getBody().get("code");
                if(code!=0){
                    throw new SysException(post.getBody().get("msg")+"");
                }
                Map<String,Object> data = (Map<String,Object>)post.getBody().get("data");
                maps.put("token",data.get("token"));
                maps.put("appId",data.get("app_id"));
            }
            return maps;
        });
    }
}
