package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.entity.CurrentUser;
import com.syc.slm.slmbi.entity.InstrumentPanel;
import com.syc.slm.slmbi.entity.InstrumentPanelDraft;

import java.util.List;
import java.util.Set;

/**
 * 仪表板草稿
 *
 * @author lin
 * @date 2021-04-01 10:52:44
 */
public interface InstrumentPanelDraftService extends IService<InstrumentPanelDraft> {

    /**
     * 发布仪表板生成仪表板草稿
     * @param panels
     */
    void saveDrafts(List<InstrumentPanel> panels);

    /**
     * 根据仪表板id获取 仪表板草稿
     * @param panelIds
     * @return
     */
    List<InstrumentPanelDraft> getByIds(Set<String> panelIds);

    /**
     * 获取仪表板信息
     * @param currentUser
     * @param appId
     * @param panelIds
     * @param officeIds
     * @param userId
     * @param roleId
     * @return
     */
    List<InstrumentPanelDraft> selectDraftList(CurrentUser currentUser,String appId,Set<String> panelIds, String officeIds, String userId, String roleId);

    /**
     * 根据仪表板id获取 仪表板草稿
     * @param panelId
     * @return
     */
    InstrumentPanelDraft getByPanelId(String panelId);
}
