package com.syc.slm.slmbi.service.impl;

import com.google.common.collect.Maps;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.config.DataCenterConfig;
import com.syc.slm.slmbi.service.PositionService;
import com.syc.slm.slmbi.vo.PositionVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 职位
 *
 * @author : lin
 * @date : 2021-03-25 18:36
 **/
@Service
public class PositionServiceImpl implements PositionService {

    @Autowired
    private DataCenterConfig dataCenterConfig;

    @Override
    public List<PositionVo> selectPositionList(String token,String appId,String name) {
        Map<String,String> uriVariables =Maps.newHashMap();
        uriVariables.put("positionName",name);
        uriVariables.put("appId",appId);

        String uri = dataCenterConfig.getDcClientHost() + dataCenterConfig.getPositionListUrl();
        R<List<PositionVo>> result = RestTemplateUtils.get(uri, new TypeToken<R<List<PositionVo>>>() {}.getType(), uriVariables);
        return result.detach();
    }
}
