package com.syc.slm.slmbi.service.impl;

import com.google.common.collect.Maps;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.config.DataCenterConfig;
import com.syc.slm.slmbi.service.UserService;
import com.syc.slm.slmbi.vo.UserTreeVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 用户信息
 *
 * @author : lin
 * @date : 2021-03-25 18:46
 **/
@Service
public class UserServiceImpl implements UserService {
    @Autowired
    private DataCenterConfig dataCenterConfig;

    @Override
    public List<UserTreeVo> selectUserList(String appId,String token,String userName) {
        Map<String,String> uriVariables =Maps.newHashMap();
        uriVariables.put("userName",userName);
        uriVariables.put("appId",appId);
        String uri = dataCenterConfig.getDcClientHost() + dataCenterConfig.getUserTree();
        R<List<UserTreeVo>> result = RestTemplateUtils.get(uri,new TypeToken<R<List<UserTreeVo>>>() {}.getType(), uriVariables);
        return result.detach();
    }
}
